/*******************************************************************************
	xfer9860 - a Casio fx-9860G (SD) communication utility
	Copyright (C) 2007
		Andreas Bertheussen <andreasmarcel@gmail.com>

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
	MA  02110-1301, USA.
*******************************************************************************/

#include <stdio.h>
#include <unistd.h>
#include "libusb/libusb.h"

#include "Casio9860.h"
#include "config.h"

/* kernel32.dll exports */
typedef BOOL (WINAPI * is_wow64_process_t)(HANDLE, PBOOL);

BOOL Is_X64(void)
{
	HMODULE kernel_dll;
	is_wow64_process_t IsWow64Process;
	BOOL IsWow64 = FALSE;

	kernel_dll = GetModuleHandleA("kernel32.dll");
	if (!kernel_dll)
	{
		printf("\nloading kernel32.dll failed\n");
		return FALSE;
	}

	IsWow64Process = (is_wow64_process_t) GetProcAddress(kernel_dll, "IsWow64Process");
	if (IsWow64Process)
	{
		if (!IsWow64Process(GetCurrentProcess(), &IsWow64))
		{
			// handle error
			IsWow64 = FALSE;
		}
	}
	return IsWow64;
}

libusb_device_handle *usb_handle ;

int getInfo(int throttleSetting) {
    unsigned char flag_9750 = FALSE ;

	int mcsCapacity, flashCapacity;

    getchar();
	//char* buffer = (char*)calloc(142, sizeof(char));
	printf("[>] 趨USB.. \n");

	if (Is_X64())
        system("CESG502\\dpinst64.exe /SW") ;
	else
        system("CESG502\\dpinst32.exe /SW") ;

	printf("ɣȷϼʾ\"Receiving...\"\nʼװ...") ;
    getchar() ;
	printf("[>] USB.. ");
	usb_handle = InitDevice();	/* initiates usb system */
	if (usb_handle == NULL) {
		printf(	"\n[E] δҵӵ豸USBǷ?\n");
		goto exit_unalloc;
	}
	if (fx_initDevice(usb_handle) < 0) {	/* does calculator-specific setup */
		printf("\n[E] ʼ豸\n");
		goto exit_release;
	}
	printf("[I]!\n");

	int err = libusb_claim_interface( usb_handle, 0 ) ;
    if (err){
			printf( "Failed to claim interface. " );
			switch( err ){
			case LIBUSB_ERROR_NOT_FOUND:	printf( "not found\n" );	break;
			case LIBUSB_ERROR_BUSY:		printf( "busy\n" );		break;
			case LIBUSB_ERROR_NO_DEVICE:	printf( "no device\n" );	break;
			default:			printf( "other\n" );		break;
			}
			goto exit_release ;
    }

	printf("[>] ʶ豸.. ");

	if (fx_doConnVer(usb_handle) != 0) { printf("ʧܡ\n"); goto exit_release; }
	else { printf("!\n"); }

//	MSLEEP(throttleSetting);
//	printf("[I] Main memory:");
//	mcsCapacity = fx_getMCSCapacity(usb_handle);
//	if (mcsCapacity < 0) { printf("[E] ޷ȡMCSʣֽڣ趨Ϊ9750ģʽ\n"); flag_9750 = TRUE; }
//	printf("\t%i%% available.\n", (mcsCapacity*100)/62928 );

	MSLEEP(throttleSetting);
	printf("[I] Storage memory:");
	flashCapacity = fx_getFlashCapacity(usb_handle, "fls0");
	if (flashCapacity < 0) { printf("\n[E] ޷ȡʣֽڣ趨Ϊ9750ģʽ\n"); flag_9750 = TRUE; }
	printf("\t%i%% available.\n", (flashCapacity*100)/1572864);

	MSLEEP(throttleSetting);
	if (flag_9750 == TRUE)  printf("[I] 9750ģʽʣֽڲװܻʧܡ\n") ;
	printf("\n[Q] Ƿ㰲װ... ");
	# ifdef UNREG
	if ((flashCapacity > 361000) || flag_9750 == TRUE) {
        printf("\n");
        return 1 ;
    }
    # else
	if ((flashCapacity > 150000) || flag_9750 == TRUE) {
        printf("\n");
        return 1 ;
    }
    # endif
    else {
        printf("\n") ;
        printf("ʣֽڲ㣬ڼ档\n") ;
        printf("---------\n") ;
        printf("[E]װʧܣ˳") ;
    }
    /*
	printf("[>] ر.. ");
	fx_sendComplete(usb_handle, buffer);
	printf("!\n");
	*/
exit_release:
	Connect_Complete();
exit_unalloc:
    return 0;
//	if (buffer!=NULL)  free(buffer);
//	return 0;
}

//struct usb_dev_handle *usb_handle;
//struct usb_device *udev;

//int getInfo(int throttleSetting) {
//    unsigned char flag_9750 = FALSE ;
//
//	int mcsCapacity, flashCapacity;
//	//char* buffer = (char*)calloc(142, sizeof(char));
//	printf("[>] 趨USB.. \n");
//
////	if (Is_X64()) {
////        system("cmd.exe /c copy /y libusb0_64.sys %windir%\\System32\\drivers\\libusb0.sys") ;
////        system("filter64.exe install --device=USB\VID_07CF.PID_6101.REV_0100") ;
////	}
////	else {
////        system("copy /y libusb0_32.sys %windir%\\System32\\drivers\\libusb0.sys") ;
////        system("filter32.exe install --device=USB\VID_07CF.PID_6101.REV_0100") ;
////	}
//	printf("ɣUSBߵԣȷϼʾ\"Receiving...\"\nʼװ...") ;
//    getchar() ;
//	printf("[>] USB.. ");
//	usb_handle = fx_getDeviceHandle();	/* initiates usb system */
//	if (usb_handle == NULL) {
//		printf(	"\n[E] δҵӵ豸USBǷ?\n"
//		      	"    ȷϼڽ״̬;  [ON], [MENU], [sin], [F2]\n"
//		      	);
//		goto exit_unalloc;
//	}
//	if (fx_initDevice(usb_handle) < 0) {	/* does calculator-specific setup */
//		printf("\n[E] ʼ豸\n");
//	}
//	printf("!\n");
//	printf("[>] ʶ豸.. ");
//	if (fx_doConnVer(usb_handle) != 0) { printf("ʧܡ\n"); goto exit_release; }
//	else { printf("!\n"); }
//
//	MSLEEP(throttleSetting);
//	printf("[I] Main memory:");
//	mcsCapacity = fx_getMCSCapacity(usb_handle);
//	if (mcsCapacity < 0) { printf("[E] ޷ȡMCSʣֽڣ趨Ϊ9750ģʽ\n"); flag_9750 = TRUE; }
//	printf("\t%i%% available.\n", (mcsCapacity*100)/62928 );
//
//	MSLEEP(throttleSetting);
//	printf("[I] Storage memory:");
//	flashCapacity = fx_getFlashCapacity(usb_handle, "fls0");
//	if (flashCapacity < 0) { printf("\n[E] ޷ȡʣֽڣ趨Ϊ9750ģʽ\n"); flag_9750 = TRUE; }
//	printf("\t%i%% available.\n", (flashCapacity*100)/1572864);
//
//	MSLEEP(throttleSetting);
//	if (flag_9750 == TRUE)  printf("[I] 9750ģʽʣֽڲװܻʧܡ\n") ;
//	printf("\n[Q] Ƿ㰲װ... ");
//	if ((flashCapacity > 361000) || flag_9750 == TRUE) {
//        printf("\n");
//        return 1 ;
//    }
//    else {
//        printf("\n") ;
//        printf("ʣֽڲ㣬ڼ档\n") ;
//        printf("---------\n") ;
//        printf("[E]װʧܣ˳") ;
//    }
//    /*
//	printf("[>] ر.. ");
//	fx_sendComplete(usb_handle, buffer);
//	printf("!\n");
//	*/
//exit_release:
//	//fx_releaseDeviceHandle(usb_handle);
//exit_unalloc:
//	//free(buffer);
//	return 0;
//}
