/*******************************************************************************
	xfer9860 - a Casio fx-9860G (SD) communication utility
	Copyright (C) 2007
		Andreas Bertheussen <andreasmarcel@gmail.com>

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
	MA  02110-1301, USA.
*******************************************************************************/

#include <stdio.h>
#include <string.h>

#include <sys/types.h>	/* stat()*/
#include <sys/stat.h>	/**/
#include <math.h>	/* ceil() */
#include "libusb/libusb.h"

#include "Casio9860.h"
#include "usbio.h"
#include "config.h"

int uploadFile(char* sourceFileName, char* destFileName, int throttleSetting) {

	int ret = 0, i, packetCount;
	char *fData, *sData, *buffer;
	struct stat sourceFileStatus;

	FILE *sourceFile = fopen(sourceFileName, "rb");
	if (sourceFile == NULL) {
		printf("[E] ޷ļ: %s\n", sourceFileName);
		return 0;
        }
	printf("[I] ҵļ: %s\n", sourceFileName);

	stat(sourceFileName, &sourceFileStatus);
	printf("[I] ļС:  %i byte(s)\n", (int)sourceFileStatus.st_size);

	packetCount = ceil(sourceFileStatus.st_size/MAX_DATA_PAYLOAD) + 1;
	printf("\n[>] ʼ %s  fls0, %i b, %i packets..\n",
	       destFileName, (int)sourceFileStatus.st_size, packetCount);
	fData = (char*)calloc(MAX_DATA_PAYLOAD, sizeof(char));
	sData = (char*)calloc(MAX_DATA_PAYLOAD*2, sizeof(char));
	buffer = (char*)calloc((MAX_DATA_PAYLOAD*2)+18, sizeof(char));	/* work buffer */
	if (fData == NULL || sData == NULL || buffer == NULL) { printf("[E] ڴʧܡ"); goto exit_unalloc; }

	fx_sendFlashFileTransmission(usb_handle, buffer, sourceFileStatus.st_size, destFileName, "fls0");
	ReadUSB(usb_handle, buffer, 6);
	if (fx_getPacketType(buffer) != T_POSITIVE) { printf("[E] ޷䡣\n"); goto exit_unalloc; }

	/* main transfer loop */
	printf("[");
	for (i = 0; i < packetCount; i++) {
		int resendCount = 0, readBytes = 0, escapedBytes = 0;
		readBytes = fread(fData, 1, MAX_DATA_PAYLOAD, sourceFile);
		escapedBytes = fx_escapeBytes(fData, sData, readBytes);
	resend_data:

		MSLEEP(throttleSetting);
		if (resendCount > 2) {
			printf("[E] в\n");
			goto exit_unalloc;
		}
		resendCount++;
		ret = fx_sendData(usb_handle, buffer, ST_FILE_TO_FLASH, packetCount, i+1, sData, escapedBytes);
		if (i % 4 == 0) { printf("#"); fflush(stdout); } /* indicates every 1kB */
		if (ReadUSB(usb_handle, buffer, 6) != 0) {
			//printf("ERR: Ӧ\n");
			goto resend_data;
		}
		if (memcmp(buffer, "\x15\x30\x31", 3) == 0) {	/* ugly way */
			//printf("ERR: õشźţ\n");
			goto resend_data;
		}
	}
	printf("]\n[I] ļ\n\n");
    free(buffer);
	free(sData);
	free(fData);
	fclose(sourceFile);
	return 1 ;
exit_unalloc:
	free(buffer);
	free(sData);
	free(fData);
exit_release:
    libusb_close(usb_handle);
    libusb_free_device_list(devs, 1); //free the list, unref the devices in it
    libusb_exit(ctx); //close the session
exit_closefile:	fclose(sourceFile);
	return 0;
}
